var action = 'Save';
var shipment_id = null;

$(document).ready(function () {
    $('#txtShipmentNo').val(newID());
    var tableAttachment = $('#myTable').DataTable({
        responsive: false,
        "scrollX": true,
        scrollY: 300,
        scrollX: true,
        "pageLength": 100,
        "order": [],
        "columns": [
            { "data": "shipment_no" },
            { "data": "shipment_type" },
            { "data": "loading_date" },
            { "data": "customer_order_id" },
            { "data": "factory_order_no" },
            { "data": "freight_by" },
            { "data": "no_of_container" },
            { "data": "container_type" },
            { "data": "action" },
            { "data": "view", className: "edit", orderable: false },
            { "data": "edit", className: "edit", orderable: false },
            { "data": "delete", className: "edit", orderable: false },
        ],
        columnDefs: [
            { width: 80, targets: 1 },
            { width: 80, targets: 2 },
            { width: 80, targets: 3 },
        ],
    });

    $("#btnShipmentSave").on("click", function (e) {

        if ($(this).text() == "Save") {
            saveSchedule();
            e.preventDefault();
        } else {
            updateSchedule(shipment_id);
        }
    });

    allShipment();
    getCustomerOrderNo();


    checkInput("#customer_order_id");
    checkInput("#no_of_container");
    checkInput("#container_type");
    checkInput("#loading_date");
    checkInput("#shipment_type");
    checkInput("#freight_by");

});

$('#btnAttachment').on('click', function () {

    $('#attachmentAddModal').modal('show');
});

function resetScheduleForm() {
    $('#formShipment').trigger("reset");
}

function saveSchedule() {

    var exterl_id = newID();
    var shipment_type = $('#shipment_type').val();

    if (shipment_type == 1) {
        if ($('#customer_order_id').attr('data-id') == '' || $('#no_of_container').val() == '' || $('#container_type').val() == '') {
            showWarningMessage("Please make sure Customer No|No of Container or Container type are filled in correctly.");
            return false;
        }
    }

    $.ajax({
        type: "POST",
        url: '/sd/shipment/saveSchedule',
        data: {
            "shipment_no": exterl_id,
            "shipment_type": $('#shipment_type').val(),
            "loading_date": $('#loading_date').val(),
            "customer_order_id": $('#customer_order_id').attr('data-id'),
            "freight_by": $('#freight_by').val(),
            "no_of_container": $('#no_of_container').val(),
            "container_type": $('#container_type').val(),
            "status": $('#status').val(),
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            // window.location.reload();
            if (response.data.success) {


                $("#attachmentAddModal").trigger("reset");

                $("#shipment_type").attr("class", "form-control");
                $("#loading_date").attr("class", "form-control");
                $("#customer_order_id").attr("class", "form-control");
                $("#freight_by").attr("class", "form-control");
                $("#no_of_container").attr("class", "form-control");
                $("#container_type").attr("class", "form-control");

                $("#txtShipmentNo").val(exterl_id);
                $("#shipment_type").val("");
                $("#loading_date").val("");
                $("#customer_order_id").val("");
                $("#freight_by").val("");
                $("#no_of_container").val("");
                $("#container_type").val("");
                $("#status").val("");

                resetScheduleForm();
                allShipment();

                toastr.success('Shipment data has been saved successful...!');
            } else {
                showWarningMessage("Please make sure all fields are filled in correctly.");
                if (response.data.result.errorInfo) {
                    showWarningMessage("Please make sure all fields are filled in correctly.");
                }
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error('Something went wrong');
        },
        complete: function () {

        }

    });
}

function updateSchedule(shipment_id) {
    var exterl_id = newID();
    $.ajax({
        type: "post",
        url: "/sd/shipment/update/" + shipment_id,
        data: {
            shipment_no: $('#txtShipmentNo').val(),
            shipment_type: $('#shipment_type').val(),
            loading_date: $('#loading_date').val(),
            customer_order_id: $('#customer_order_id').val(),
            freight_by: $('#freight_by').val(),
            no_of_container: $('#no_of_container').val(),
            container_type: $('#container_type').val(),
            status: $('#status').val(),
        },
        headers: {
            "X-CSRF-TOKEN": $('meta[name="csrf-token"]').attr("content"),
        },
        timeout: 800000,
        beforeSend: function () {
            $("#attachmentAddModal").trigger("reset");

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                allShipment();
                $("#attachmentAddModal").trigger("reset");
                $("#btnShipmentSave").text("Save");
                $("#txtShipmentNo").val(exterl_id).removeClass("is-valid is-invalid");
                $("#shipment_type").val("").removeClass("is-valid is-invalid");
                $("#loading_date").val("").removeClass("is-valid is-invalid");
                $("#customer_order_id").val("").removeClass("is-valid is-invalid");
                $("#freight_by").val("").removeClass("is-valid is-invalid");
                $("#no_of_container").val("").removeClass("is-valid is-invalid");
                $("#container_type").val("").removeClass("is-valid is-invalid");
                $("#status").val("").removeClass("is-valid is-invalid");
                $(".is-invalid").hide().removeClass("is-valid is-invalid");
                $(".is-valid").hide().removeClass("is-valid is-invalid");
                toastr.success("data updated").removeClass("is-valid is-invalid");
                $("#attachmentAddModal").trigger("reset");
            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            toastr.error("Something went wrong");
        },
        complete: function () { },
    });
}

function allShipment() {
    $.ajax({
        type: "GET",
        url: "/sd/shipment/allShipment",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var result = response.data.result;
                var data = [];
                var ShipmentType = '';
                var freightBy = '';
                var factory_order_no = '';
                var containerType = '';
                for (var i = 0; i < result.length; i++) {
                    var shipment_id = response.data.result[i]["shipment_id"];
                    var status = response.data.result[i]["status"];
                    var shipment_type = response.data.result[i]["shipment_type"];
                    var freight_by = response.data.result[i]["freight_by"];
                    var container_type = response.data.result[i]["container_type"];
                    var factory_order_no = response.data.result[i]["factory_order_no"];

                    // if (seen == 0) {
                    //     var seenIcon = '<span class="badge badge-danger"><i class="fa fa-times" aria-hidden="true"></i></span>'
                    // } else {
                    //     var seenIcon = '<span class="badge badge-success"><i class="fa fa-check" aria-hidden="true"></i></span>'
                    // }

                    // for shipment type
                    switch (shipment_type) {
                        case '':
                            ShipmentType = 'unspecified';
                            break;
                        case 1:
                            ShipmentType = 'Finished Goods';
                            break;
                        case 2:
                            ShipmentType = 'Sample';
                    }
                    // for freight_by
                    switch (freight_by) {
                        case '':
                            freightBy = 'unspecified';
                            break;
                        case 1:
                            freightBy = 'Sea Freight';
                            break;
                        case 2:
                            freightBy = ' Air Fraight';
                    }
                    // for shipment type
                    switch (container_type) {
                        case '':
                            containerType = 'unspecified';
                            break;
                        case 1:
                            containerType = '20FT General';
                            break;
                        case 2:
                            containerType = '40FT General';
                            break;
                        case 3:
                            containerType = '20FT High Cube';
                            break;
                        case 4:
                            containerType = '40FT High Cube';
                            break;
                    }


                    switch (status) {
                        case 0:
                            StatusIcon = '<span class="badge badge-primary">New</span>';
                            break;
                        case 1:
                            StatusIcon = '<span class="badge badge-success">Approved</span>';
                            break;
                        case 2:
                            StatusIcon = '<span class="badge badge-info">Revise</span>';
                            break;
                        case 3:
                            StatusIcon = '<span class="badge badge-danger">Reject</span>';
                    }

                    // action btn define
                    var vessel_action_button = '<div class="dropdown">';
                    vessel_action_button += '<button type="button" class="btn btn-primary dropdown-toggle" data-toggle="dropdown">';
                    vessel_action_button += ' Action';
                    vessel_action_button += '</button>';
                    vessel_action_button += '<div class="dropdown-menu">';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_scheduled(' + factory_order_no + ')">Vessel Schedule</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="release_order(' + shipment_id + ')">Release order</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="loading_plan(' + shipment_id + ')">Loading Plan</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="packing_slip(' + shipment_id + ')">Packing Slip</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="palate_label(' + shipment_id + ')">Palate Label</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="special_intruction_for_loading(' + shipment_id + ')">Special Intruction For Loading</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="special_document(' + shipment_id + ')">Special Document</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="preshipment_doc(' + shipment_id + ')">Pre-shipment Documents  </a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="furmugations(' + shipment_id + ')">Fumigations </a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="bl_instruction(' + shipment_id + ')">B/L instruction</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="inform_usa_office(' + shipment_id + ')">Inform USA Office</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="collecting_final_document(' + shipment_id + ')">Collecting Final Document</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="clearance_document_usa(' + shipment_id + ')">Clearance Documents USA</a>';
                    vessel_action_button += '</div></div>';


                    data.push({
                        "shipment_no": result[i].shipment_no,
                        "shipment_type": ShipmentType,
                        "loading_date": result[i].loading_date,
                        "customer_order_id": result[i].customer_order_id,
                        "factory_order_no": result[i].factory_order_no,
                        "freight_by": freightBy,
                        "no_of_container": result[i].no_of_container,
                        "container_type": containerType,
                        "action": vessel_action_button,
                        "view": '<button type= "button" class="btn btn-success" onclick="viewShipment(' + shipment_id + ');"><i class="fa fa-eye" aria-hidden="true"></i></button> ',
                        "edit": '<button type= "button" class="btn btn-primary" onclick="editShipment(' + shipment_id + ');"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button> ',
                        "delete": '<button type= "button" class="btn btn-danger" onclick="deleteShipment(' + shipment_id + ');"><i class="fa fa-trash" aria-hidden="true"></i></button> ',
                    });
                }
                var table = $('#myTable').DataTable();
                table.clear();
                table.rows.add(data).draw();
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}

function getShipmentData(id) {
    $.ajax({
        type: "GET",
        url: "/sd/shipment/getShipmentData/" + id,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () { },
        success: function (response) {
            if (response.data.success) {
                var res = response.data.result;
                $("#txtShipmentNo").val(res.shipment_no);
                $("#shipment_type").val(res.shipment_type);
                $("#loading_date").val(res.loading_date);
                $("#customer_order_id").val(res.customer_order_id);
                $("#freight_by").val(res.freight_by);
                $("#no_of_container").val(res.no_of_container);
                $("#container_type").val(res.container_type);
                $("#status").val(res.status);
            }
        },
        error: function (error) {
            console.log(error);
        },
        complete: function () {
            // progress(false);
        },
    });
}

function getCustomerOrderNo() {
    $.ajax({
        type: "GET",
        url: "/sd/shipment/getOrderNo",
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                var customer_id = response.data.result;
                $("#customer_order_id").setData(customer_id);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}

function viewShipment(id) {
    getShipmentData(id);
    $("#btnShipmentSave").hide();
    $('#attachmentAddModal').modal('toggle');
}

function editShipment(id) {
    shipment_id = id;
    getShipmentData(id);
    $("#btnShipmentSave").text("Update");
    $("#attachmentAddModal").modal("toggle");
}

function deleteShipment(id) {

    showAlert("Are You Sure?", id);
}

function showAlert(message, id) {
    swal({
        title: message,
        text: "Once deleted, you will not be able to recover this record!",
        icon: "warning",
        buttons: true,
        dangerMode: true,
    });

    $(".swal-button--confirm").on("click", function () {
        $.ajax({
            type: "DELETE",
            url: "/sd/shipment/delete/" + id,
            data: {
                shipment_id: id,
            },
            headers: {
                'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
            },
            processData: false,
            contentType: false,
            cache: false,
            timeout: 800000,
            beforeSend: function () {

            },
            success: function (response) {
                console.log(response);
                if (response.data.success) {
                    allShipment();
                    showSuccessMessage("Attachment has been deleted successfully...");

                } else {
                    showErrorMessage();
                }

            },
            error: function (error) {
                console.log(error);

            },
            complete: function () {

            }
        });
    });
}

function vessel_scheduled(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/vsCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            if (res.length > 0) {
                window.location.href = 'vesselScheduleList/' + res[0].factory_po_num;
            } else {
                window.location.href = 'vesselSchedule?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}


function release_order(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/roCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'releaseOrderList/' + res[0].factory_po;
            } else {
                window.location.href = 'releaseOrder?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}

function bl_instruction(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/biCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'blInstructionList/' + res[0].factory_po;
            } else {
                window.location.href = 'blInstruction?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}
function loading_plan(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/lpCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'loardingPlanList/' + res[0].factory_po;
            } else {
                window.location.href = 'loardingPlan?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}
function special_document(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/sdCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'specialDocumentList/' + res[0].factory_po;
            } else {
                window.location.href = 'specialDocument?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}
function preshipment_doc(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/pdocCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'preshipmentDocumentList/' + res[0].factory_po;
            } else {
                window.location.href = 'preshipmentDocument?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}
function furmugations(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/furCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'furmugationsList/' + res[0].factory_po;
            } else {
                window.location.href = 'furmugations?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}
function inform_usa_office(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/informUSACheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'informUsaOfficeList/' + res[0].factory_po;
            } else {
                window.location.href = 'informUsaOffice?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}
function clearance_document_usa(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/cdUSACheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'clearanceDocumentsUsaList/' + res[0].factory_po;
            } else {
                window.location.href = 'clearanceDocumentsUsa?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}
function collecting_final_document(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/cfdCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'collectingFinalDocumentList/' + res[0].factory_po;
            } else {
                window.location.href = 'collectingFinalDocument?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}
function special_intruction_for_loading(id) {
    // window.location.href = 'vesselScheduleList';

    $.ajax({
        type: "GET",
        url: "/sd/shipment/spInsForLoadingCheckAvailability/" + id,
        data: {
            shipment_id: id,
        },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);
            if (res.length > 0) {
                window.location.href = 'specInsForLoadingList/' + res[0].factory_po;
            } else {
                window.location.href = 'specInsForLoading?id=' + id + "&action=create";
            }

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });

}



function packing_slip(id) {
    window.location.href = 'packing_slip?id=' + id + "&action=create";
}


function palate_label(id) {



    $.ajax({
        type: "GET",
        url: "/sd/shipment/palate_label/" + id,
        data: {},
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            var res = response.data.result;
            console.log(res);

            var path = 'https://erp.rbs.lk/assets/media/image/single_logo.PNG';
            var logo_width = 238;
            const img = new Image();
            img.src = path;
            img.addEventListener('load', function (event) {
                const canvas = document.createElement('canvas');
                const ctx = canvas.getContext('2d');
                canvas.width = event.currentTarget.width;
                canvas.height = event.currentTarget.height;
                ctx.drawImage(event.currentTarget, 0, 0);
                const dataurl = canvas.toDataURL('image/jpeg');
                showPalletLabelReport(dataurl, res, 'PRINT');

            });

        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }
    });


}



function showPalletLabelReport(dataurl, result, flag) {

    var Body = [];



    var Title = [
        {
            text: '\n',
            alignment: 'center'
        },
        {
            text: 'Riococo Lanka Pvt Ltd',
            alignment: 'center',
            fontSize: 12,
            bold: true,
        },

    ];


    var Header = [
        {
            content: [
                {
                    text: '',
                    alignment: 'center'
                },
                {
                    text: '\n',
                    alignment: 'center'
                },
            ]
        }
    ]


    var Body = [];
    for (var i = 0; i < result.no_of_pallet; i++) {
        Body.push(palletLabelReportBody(dataurl, i, result));
        if (i % 2 == 1 && (i + 1) < result.no_of_pallet) {
            Body.push({ text: '', pageBreak: 'after' });
        }
    }


    var Footer = [
        {
            color: 'red',
            fontSize: 8,
            alignment: 'center',
            margin: [0, 0]
        }
    ];




    var page = new Page();
    page.setPageSize('A4');
    page.setPageOrientation('portrait');
    page.setPageMargin([5, 5, 5, 5]);
    page.setTitle(Title);
    page.setHeader(Header, Page.EVERY);
    page.setBody(Body);
    page.setFooter(Footer);
    if (flag == 'EXPORT') {
        page.export();
    } else if (flag == 'PRINT') {
        page.preview();
    }
}




function palletLabelReportBody(dataurl, pallet_no, result) {




    var body = [
        [
            {
                table: {
                    widths: ['*'],
                    body: [[{ text: 'DRY COIR BLOCK (W)', fontSize: 18, bold: true, alignment: 'center', border: [true, true, true, false] }], [{ text: '(PCM OTB 1 GALLON)', fontSize: 16, bold: true, alignment: 'center', border: [true, false, true, true] }]],

                },
                layout: {
                    paddingTop: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingLeft: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingRight: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingBottom: function (i, node) {
                        return i === 0 ? 0 : 0;
                    },
                    hLineWidth: function (i, node) {
                        return 1;
                    },
                    vLineWidth: function (i, node) {
                        return 1;
                    }
                },
                margin: [0, 0],
                border: [false, false, false, false], colSpan: 2
            },
            { text: '', fontSize: 10, bold: true, alignment: 'center', border: [true, true, true, true] },
        ]

    ];



    body.push(
        [
            {
                table: {
                    widths: ['*'],
                    body: [[{ text: 'DIMENSIONS:', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] }], [{ text: '\n\n' }]],

                },
                layout: {
                    paddingTop: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingLeft: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingRight: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingBottom: function (i, node) {
                        return (i === node.table.widths.length - 1) ? 0 : 0;
                    },
                    hLineWidth: function (i, node) {
                        return 1;
                    },
                    vLineWidth: function (i, node) {
                        return 1;
                    }
                },
                margin: [0, 0],
                border: [false, false, false, false]
            },
            {
                table: {
                    widths: ['*'],
                    body: [[{ text: 'PRE CUT HOLES :', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] }], [{ text: '\n\n' }]],

                },
                layout: {
                    paddingTop: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingLeft: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingRight: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingBottom: function (i, node) {
                        return i === 0 ? 0 : 0;
                    },
                    hLineWidth: function (i, node) {
                        return 1;
                    },
                    vLineWidth: function (i, node) {
                        return 1;
                    }
                },
                margin: [0, 0],
                border: [false, false, false, false]
            },
        ],
    );

    body.push(
        [
            {
                table: {
                    widths: ['*'],
                    body: [[{ text: 'BUYER:', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] }], [{ text: '\n\n' }]],

                },
                layout: {
                    paddingTop: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingLeft: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingRight: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingBottom: function (i, node) {
                        return i === 0 ? 0 : 0;
                    },
                    hLineWidth: function (i, node) {
                        return 1;
                    },
                    vLineWidth: function (i, node) {
                        return 1;
                    }
                },
                margin: [0, 0],
                border: [false, false, false, false]
            },
            {
                table: {
                    widths: ['*', '*'],
                    body: [[{ text: 'PRODUCT CODE:', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] }, { text: 'MANUFACTURE DATE', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] }], [{ text: '\n\n' }, { text: '\n\n' }]],

                },
                layout: {
                    paddingTop: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingLeft: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingRight: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingBottom: function (i, node) {
                        return i === 0 ? 0 : 0;
                    },
                    hLineWidth: function (i, node) {
                        return 1;
                    },
                    vLineWidth: function (i, node) {
                        return 1;
                    }
                },
                margin: [0, 0],
                border: [false, false, false, false]
            },
        ],
    );

    body.push(
        [
            {
                table: {
                    widths: ['*', '*'],
                    body: [[{ text: 'ORDER QUANTITY :', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] }, { text: 'PALLET QUANTITY:', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] }], [{ text: '\n\n', alignment: 'center' }, { text: '\n '+result.no_of_pallet, alignment: 'center' }]],

                },
                layout: {
                    paddingTop: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingLeft: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingRight: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingBottom: function (i, node) {
                        return i === 0 ? 0 : 0;
                    },
                    hLineWidth: function (i, node) {
                        return 1;
                    },
                    vLineWidth: function (i, node) {
                        return 1;
                    }
                },
                margin: [0, 0],
                border: [false, false, false, false]
            },
            {
                table: {
                    widths: ['*', '*'],
                    body: [[{ text: 'CUSTOMER PO # :', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] }, { text: 'RIOCOCO PO #', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] }], [{ text: '\n '+result.purchase_order, alignment: 'center' }, { text: '\n '+result.factory_po, alignment: 'center' }]],

                },
                layout: {
                    paddingTop: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingLeft: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingRight: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingBottom: function (i, node) {
                        return i === 0 ? 0 : 0;
                    },
                    hLineWidth: function (i, node) {
                        return 1;
                    },
                    vLineWidth: function (i, node) {
                        return 1;
                    }
                },
                margin: [0, 0],
                border: [false, false, false, false]
            },
        ],
    );
    body.push(
        [
            //{ text: 'Riococo Lanka (PVT) Ltd \n Siyambalangamuwa \n Bamunakotuwa \n Sri Lanka \n Tel : +94 37 562 73 27', fontSize: 10, bold: false, alignment: 'left', border: [true, false, true, true], colSpan: 2 },
            //{ text: '', fontSize: 10, bold: false, alignment: 'center', border: [true, true, true, true] },
            {
                table: {
                    widths: ['*'],
                    body: [
                        [
                            { text: 'Manufactured By :', fontSize: 10, bold: false, alignment: 'left', border: [true, true, true, false] }
                        ],
                        [
                            { text: 'Riococo Lanka (PVT) Ltd', fontSize: 10, bold: true, alignment: 'left', border: [true, false, true, false] }
                        ],
                        [
                            { text: 'Siyambalangamuwa', fontSize: 10, bold: true, alignment: 'left', border: [true, false, true, false] }
                        ],
                        [
                            { text: 'Bamunakotuwa', fontSize: 10, bold: true, alignment: 'left', border: [true, false, true, false] }
                        ],
                        [
                            { text: 'Tel : +94 37 562 73 27', fontSize: 10, bold: true, alignment: 'left', border: [true, false, true, true] }
                        ],
                        [
                            { text: 'MADE IN SRI LANKA', fontSize: 10, bold: true, alignment: 'center', border: [true, true, true, true] }
                        ]
                    ],

                },
                layout: {
                    paddingTop: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingLeft: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingRight: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingBottom: function (i, node) {
                        return i === 0 ? 0 : 0;
                    },
                    hLineWidth: function (i, node) {
                        return 1;
                    },
                    vLineWidth: function (i, node) {
                        return 1;
                    }
                },
                margin: [0, 0],
                border: [false, false, false, false], colSpan: 2
            },
            { text: '', fontSize: 10, bold: true, alignment: 'center', border: [true, true, true, true] },
        ],
    );


    var content = [
        [{
            table: {
                widths: ['*', '*'],
                heights: 20,
                headerRows: 2,
                body: body,

            },
            layout: {
                paddingTop: function (i) {
                    return i === 0 ? 0 : 0;
                },
                paddingLeft: function (i) {
                    return i === 0 ? 0 : 0;
                },
                paddingRight: function (i) {
                    return i === 0 ? 0 : 0;
                },
                paddingBottom: function (i, node) {
                    return (i === node.table.widths.length - 1) ? 0 : 0;
                },
                hLineWidth: function (i, node) {
                    return 1;
                },
                vLineWidth: function (i, node) {
                    return 1;
                }
            },
            margin: [2, 2],

        }],
    ];




    return {
        table: {
            widths: ['*'],
            body: [[{
                table: {
                    widths: ['*', '*'],
                    body: [[{
                        stack: [{ image: dataurl, width: 220, height: 30 }]
                    }, { text: 'PALLET NO : ' + (pallet_no + 1), border: [false, false, false, false] }]],

                },
                layout: {
                    paddingTop: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingLeft: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingRight: function (i) {
                        return i === 0 ? 0 : 0;
                    },
                    paddingBottom: function (i, node) {
                        return (i === node.table.widths.length - 1) ? 0 : 0;
                    },
                    hLineWidth: function (i, node) {
                        return 0;
                    },
                    vLineWidth: function (i, node) {
                        return 1;
                    }
                },
                margin: [0, 0],
            },], content,],

        },
        layout: {
            paddingTop: function (i) {
                return i === 0 ? 0 : 0;
            },
            paddingLeft: function (i) {
                return i === 0 ? 0 : 0;
            },
            paddingRight: function (i) {
                return i === 0 ? 0 : 0;
            },
            paddingBottom: function (i, node) {
                return (i === node.table.widths.length - 1) ? 0 : 0;
            },
            hLineWidth: function (i, node) {
                return 0.5;
            },
            vLineWidth: function (i, node) {
                return 0.5;
            }
        },
        margin: [50, 0],
    };
}


/**
 * showSuccessMessage
 * This function is used to show success message.
 * @param message This is the paramter to require message content
 */
function showSuccessMessage(message) {
    toastr.success(message);
}

/**
 * showWarningMessage
 * This function is used to show warning message.
 * @param message This is the paramter to require message content
 */
function showWarningMessage(message) {
    toastr.warning(message);
}

/**
 * showErrorMessage
 * This function is used to show error message.
 * @param message This is the paramter to require message content
 */
function showErrorMessage() {
    toastr.error("Something went wrong");
}
